-module(n4u_client).
-include_lib("n4u/include/n4u.hrl").

-export([info/3]).

info({client, Message}, Req, State) ->
  wf:info(?MODULE, "Client Message: ~p", [Message]),
  Module = State#cx.module,
  Reply = try Module:event({client, Message})
  catch E:R:Stk ->
    wf:error(?MODULE, "Catch: ~p:~p~n~p", [E, R, Stk]),
    [E, R, Stk]
  end,
  {reply, wf:format({io, n2o_nitrogen:render_actions(erlang:get(actions)), Reply}), Req, State};

info({server, Message}, Req, State) ->
  wf:info(?MODULE, "Server Message: ~p", [Message]),
  Module = State#cx.module,
  Reply = try Module:event({server, Message})
  catch E:R:Stk ->
    wf:error(?MODULE, "Catch: ~p:~p~n~p", [E, R, Stk]),
    [E, R, Stk]
  end,
  {reply, wf:format({io, n2o_nitrogen:render_actions(erlang:get(actions)), Reply}), Req, State};

info(Message, Req, State) -> {unknown, Message, Req, State}.

